#!/usr/bin/env python
# this runs on the host linux machine (base station).  It takes in keyboard inputs with a Tkinter interface and republishes it as /irobotcreate2/instructions.msg

from irobotcreate2.msg import instructions
import rospy

from Tkinter import Tk, Frame, Label, Button
import signal
import sys

class keyboard_grabber:
    def __init__(self, parent):
        self.parent = parent

        parent.title("Create2 keyboard teleop")

        w = Label(parent, text="Enter commands here, drive with WASD", fg="black").pack()
        s = Label(parent, text="Quit with 'esc'", fg="red").pack()

        self.toMove = instructions()


    def kb_callback(self,event):
        if event.keysym == 'Escape':
            print "bye"
            root.destroy()
            sys.exit(0)
        x = event.char
        if x == "w":
            root.after_cancel(self.job)
            print "w: forward" 
            self.send_instructions(0.25, 0, 0.25, 0)
            self.job = root.after(500, self.zero_out)
        elif x == "a":
            root.after_cancel(self.job)
            print "a: ccw"
            self.send_instructions(-0.25, 0, 0.25, 0)
            self.job = root.after(500, self.zero_out)
        elif x == "s":
            root.after_cancel(self.job)
            print "s: backward"
            self.send_instructions(-0.25, 0, -0.25, 0)
            self.job = root.after(500, self.zero_out)
        elif x == "d":
            root.after_cancel(self.job)
            print "d: cw"
            self.send_instructions(0.25, 0, -0.25, 0)
            self.job = root.after(500, self.zero_out)
        else:
            root.after_cancel(self.job)
            print "nope"
            self.send_instructions(0, 0, 0, 0)
            self.job = root.after(100, self.zero_out)

    def send_instructions(self, lsud, lslr, rsud, rslr):
        self.toMove.left_stick_up_down = lsud 
        self.toMove.left_stick_left_right = lslr
        self.toMove.right_stick_up_down = rsud
        self.toMove.right_stick_left_right = rslr
        pub.publish(self.toMove)

    def zero_out(self):
        self.job = root.after_cancel(self.job)
        self.send_instructions(0, 0, 0, 0)
        self.job = root.after(100, self.zero_out)

def signal_handler(signal, frame):
    print('Ctrl+C detected, closing down gracefully...')
    root.destroy()
    sys.exit(0)


if __name__ == '__main__':
    pub = rospy.Publisher('instructions', instructions, queue_size=10)
    rospy.init_node('host_keyboard_teleop', anonymous=True)

    root = Tk()
    root.geometry('{}x{}'.format(300, 300))
    keyboardgrabber = keyboard_grabber(root) 
    signal.signal(signal.SIGINT, signal_handler)

    root.bind("<Key>", keyboardgrabber.kb_callback)
    keyboardgrabber.job = root.after(500, keyboardgrabber.zero_out)

    root.mainloop()
