#!/usr/bin/env python
# this runs on the target linux machine attached to the create2, it subscribes to the instructions topic and acts accordingly


from irobotcreate2.msg import instructions 
from irobotcreate2 import Create2Class
import rospy

import signal
import sys

def signal_handler(signal, frame):
    print '\n' + "Ctrl+C detected, closing down gracefully..."
    create2.closeCreate2()
    sys.exit(0)

def callback(data):
    left_ud = data.left_stick_up_down
    right_ud = data.right_stick_up_down
    rospy.loginfo( rospy.get_caller_id() + "LSUD: %f", left_ud )
#   rospy.loginfo( rospy.get_caller_id() + "LSLR: %f", data.left_stick_left_right)
    rospy.loginfo( rospy.get_caller_id() + "RSUD: %f", right_ud )
#   rospy.loginfo( rospy.get_caller_id() + "RSLR: %f", data.right_stick_left_right)
    create2.driveDirect(left_ud*500, right_ud*500)

def init():
    rospy.init_node('target_create2')
    rospy.Subscriber("/host/instructions", instructions, callback)
   # create2.onConnect("/dev/ttyUSB0")
    create2.getFirmware()
    rospy.spin()

if __name__ == '__main__':
    create2 = Create2Class.Create2Class("/dev/ttyUSB0") # Change "/dev/ttyUSB0" to reflect your serial cable path.
    signal.signal(signal.SIGINT, signal_handler)
    print "Battery voltage: " + str(create2.readVoltage()) + "mV"
    print "Battery Charge: " + str(create2.readCharge()) + "mAh"
    print "Battery Capacity: " + str(create2.readCapacity()) + "mAh"
    print "Charging State: " + str(create2.getChargeState())

    init()
